package api

import (
	"fmt"

	"github.com/energye/energy/v2/cef"
	"github.com/energye/golcl/lcl/types"
)

func NewWeb(url, title string, w, h float32) *cef.LCLBrowserWindow {
	wp := cef.NewWindowProperty()
	wp.Url = url
	wp.Title = title

	wp.EnableMinimize = true
	wp.EnableCenterWindow = true
	browser := cef.NewLCLBrowserWindow(nil, wp)
	width := int32(w)
	height := int32(h)
	if width == 0 {
		width = 1280
	}
	if height == 0 {
		height = 720
	}
	if w <= 1 {
		width = int32(float32(ScreenWidth) * w)
	}
	if h <= 1.0 {
		height = int32(float32(ScreenHeight) * h)
	}
	browser.SetWidth(width)
	browser.SetHeight(height)
	browser.SetShowInTaskBar()
	browser.WorkAreaCenter()
	browser.EnableAllDefaultEvent()

	fmt.Println("open web=>", url, title, width, height)

	cef.QueueAsyncCall(func(id int) {
		browser.Show()
		if browser.WindowState() == types.WsMinimized {
			fmt.Println("WsMinimized windows")
			browser.Restore()
		}
	})

	return browser
}
