package cefclient

import (
	"bufio"
	"fmt"
	"io"
	"os/exec"
	"path"
	"regexp"
)

// 启动系统bus
func StartCefclient(exeDir string, dataDir string) error {

	//使用操作系统的 API 重启应用程序
	configerFpath := path.Join(exeDir, "bin", "cefclient", "cefclient.exe")
	confpath := path.Join(exeDir, "bin", "cefclient", "app.yaml")

	cmd := exec.Command(configerFpath, "--conf", confpath, "--data", dataDir)

	// cmd.SysProcAttr = &syscall.SysProcAttr{CreationFlags: syscall.CREATE_NEW_PROCESS_GROUP}
	stdoutIn, e := cmd.StdoutPipe()
	if e != nil {
		return e
	}
	reader := bufio.NewReader(stdoutIn)
	chDown := make(chan int, 1)
	go func() {
		regex, _ := regexp.Compile(fmt.Sprintf("%s is running", "cefclient.exe"))
		checked := false
		for {
			line, err2 := reader.ReadString('\n')
			if err2 != nil || io.EOF == err2 {
				chDown <- 2
				break
			}
			fmt.Println(line)

			if !checked {
				match := regex.MatchString(line)
				if match {
					checked = true
					chDown <- 1
				}
			}
		}
	}()
	err := cmd.Start()
	if err != nil {
		fmt.Println(err)
		return err
	}

	t := <-chDown
	if t != 1 {
		return fmt.Errorf("启动sysbus失败")
	}

	// // 使用信号通知来捕获主进程退出信号
	// signalCh := make(chan os.Signal, 1)
	// signal.Notify(signalCh, os.Interrupt, syscall.SIGTERM)

	// // 等待主进程退出信号
	// <-signalCh

	// // 收到退出信号后，向cefclient.exe发送终止信号
	// if err := cmd.Process.Signal(os.Interrupt); err != nil {
	// 	fmt.Println("无法终止cefclient.exe：", err)
	// 	return nil
	// }

	// 等待cefclient.exe退出
	if err := cmd.Wait(); err != nil {
		fmt.Println("等待cefclient.exe退出时发生错误：", err)
		return nil
	}

	fmt.Println("cef client quited")

	return nil
}
