package main

import (
	"fmt"
	"os"
	"path"

	"github.com/nats-io/nats-server/v2/server"
	"github.com/nats-io/nats.go"
)

type NatsMrg struct {
	server *server.Server

	nc *nats.Conn

	moniterPort int
}

func (m *NatsMrg) Quit() {
	if m.server != nil {
		m.server.Shutdown()
	}
}

func (m *NatsMrg) InitRun(ws, port int) error {

	mport, _ := GetFreePort()

	storep := path.Join(AppDataDir, "jstream")
	os.MkdirAll(storep, os.ModePerm)
	opts := &server.Options{
		ServerName: "infish-bus",
		Port:       port,
		JetStream:  true,
		StoreDir:   storep,
		HTTPPort:   mport,
		Websocket: server.WebsocketOpts{
			Port:  ws,
			NoTLS: true,
		},
	}
	s, e := server.NewServer(opts)
	if e != nil {
		fmt.Println("new nats error=>", e)
		return e
	}
	s.ConfigureLogger()

	s.Start()

	m.moniterPort = mport
	m.server = s

	return nil
}

var gNatsMrg = &NatsMrg{}
